SystemOrganization addCategory: #'LegoIR-Core'!

Object subclass: #LegoIRTower
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LegoIR-Core'!

LegoIRTower class
	instanceVariableNames: 'myInstance users'!

!LegoIRTower commentStamp: 'Richo 2/10/2009 15:23' prior: 0!
Representa una torre infrarroja de Lego. Usa el plugin sapien.dll para la comunicacin. Slo permite una torre conectada por vez, y para asegurar que varios robots puedan usarla implementa algo parecido a un singleton.!

LegoIRTower class
	instanceVariableNames: 'myInstance users'!

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 14:12'!
apiConnect: aPort 
	<apicall: void 'sapien_open' (char*) module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 14:12'!
apiDisconnect
	<apicall: void 'sapien_close' () module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 14:12'!
apiSend: hexCode noWakeUp: cero 
	<apicall: void 'sapien_send' (short short) module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 14:13'!
connectOnPort: aNumber
self apiConnect: 'COM', aNumber asString! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 15:17'!
disconnect
"Desconecto la torre cuando no hay ms usuarios"
	users isEmpty
		ifTrue: [self apiDisconnect.
			myInstance := nil]! !

!LegoIRTower class methodsFor: 'accessing' stamp: 'Richo 2/10/2009 15:16'!
isConnected
^myInstance notNil! !

!LegoIRTower class methodsFor: 'instance creation' stamp: 'Richo 2/10/2009 14:05'!
new
self shouldNotImplement! !

!LegoIRTower class methodsFor: 'instance creation' stamp: 'Richo 2/10/2009 15:15'!
onPort: aSmallInteger 
	"Slo puede haber una torre conectada en un puerto. Registro los
	usuarios de la clase para saber cuando desconectar realmente la torre
	(cuando no haya ms usuarios)"
	(self isConnected
			and: [myInstance port ~= aSmallInteger])
		ifTrue: [^ self error: 'Already connected on port ' , myInstance port asString].
	self registerAsUser: thisContext client.
	self isConnected
		ifTrue: [^ myInstance]
		ifFalse: [^ myInstance := self basicNew setPort: aSmallInteger;
						 connect]! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 2/10/2009 14:46'!
registerAsUser: anObject 
self users add: anObject! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 2/10/2009 14:51'!
removeAsUser: anObject
	users remove: anObject ifAbsent: [self error: 'Absent user (CHAN!!)']
	! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 2/10/2009 14:13'!
send: hexCode noWakeUp: cero 
	self apiSend: hexCode noWakeUp: cero! !

!LegoIRTower class methodsFor: 'accessing' stamp: 'Richo 2/10/2009 15:06'!
users
	"Usuarios de la torre, cuando ya no hay usuarios desconecta realmente
	la torre"
	^ users
		ifNil: [users := Set new]! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 2/11/2009 14:53'!
connect
	"Slo conecto si todava no est conectado"
	self class isConnected
		ifFalse: [self class connectOnPort: port]! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 2/10/2009 14:50'!
disconnect

	self class removeAsUser: thisContext client; disconnect! !

!LegoIRTower methodsFor: 'accessing' stamp: 'Richo 2/10/2009 14:11'!
port 
^port! !

!LegoIRTower methodsFor: 'sending' stamp: 'Richo 2/10/2009 14:14'!
send: hexCode noWakeUp: cero
self class send: hexCode noWakeUp: cero! !

!LegoIRTower methodsFor: 'private' stamp: 'Richo 2/10/2009 14:11'!
setPort: aNumber
port := aNumber! !
